#include <stdio.h>
#include <sys/time.h>
#define TIMEOUT_PRIORITY_CONF 0
#define TIMEOUT_PRIORITY_APP 1

void check(time_t now, int qe_parent_timeout, int qe_parent_timeoutpriority, long qe_expire) {
	long to;
	char buf[10];
    
	if (qe_expire) {
		if (qe_expire-now==0) {
			snprintf(buf,sizeof(buf), "T");
		} else {
			snprintf(buf,sizeof(buf), "T+%d", qe_expire-now);
		}
	} else {
		snprintf(buf,sizeof(buf),"0");
	}

	printf("%9s   | %10d       |  %10d         | %10s      |",buf, qe_expire ? qe_expire-now : 0, qe_parent_timeout, qe_parent_timeoutpriority==TIMEOUT_PRIORITY_APP ? "APP" : "CONF" );
    
	/* old */
	if (qe_expire && (!qe_parent_timeout || (qe_expire - now) <= qe_parent_timeout))
		to = (qe_expire - now) * 1000;
	else
		to = (qe_parent_timeout) ? qe_parent_timeout * 1000 : -1;

	printf("%7ld   |",to);    

	/* new */
	if (qe_expire && (!qe_parent_timeout || (qe_parent_timeoutpriority == TIMEOUT_PRIORITY_APP && (qe_expire - now) <= qe_parent_timeout)))
		to = (qe_expire - now) * 1000;
	else
		to = (qe_parent_timeout) ? qe_parent_timeout * 1000 : -1;

	printf("%7ld   |",to);    


	/* proposal1 */	
	if (qe_expire && qe_expire<=now) {
		to = 0;
	} else if (qe_parent_timeout) {
		to = qe_parent_timeout * 1000;
	} else {
		to = -1;
	}

	printf("%12ld    |",to);

	/* proposal2 */	
	if (qe_parent_timeoutpriority == TIMEOUT_PRIORITY_APP) {
		if (qe_expire && (!qe_parent_timeout || (qe_expire - now) <= qe_parent_timeout))
			to = (qe_expire - now) * 1000;
		else
			to = (qe_parent_timeout) ? qe_parent_timeout * 1000 : -1;
	} else {
		if (qe_expire && qe_expire<=now) {
			to = 0;
		} else if (qe_parent_timeout) {
			to = qe_parent_timeout * 1000;
		} else {
			to = -1;
		}
	}

	printf("%12ld\n",to);
}

int main() {
    time_t now = time(NULL);
    
    printf(" qe->expire | qe->expire - now | qe->parent->timeout | timeoutpriority | to (old) | to (new) | to (proposal1) | to (proposal2) \n");
    printf("------------|------------------|---------------------|-----------------|----------|----------|----------------|----------------\n");
    
	check(now, 10, TIMEOUT_PRIORITY_CONF, now+20);
	check(now, 10, TIMEOUT_PRIORITY_CONF, now+10);
	check(now, 10, TIMEOUT_PRIORITY_CONF, now+5);
	check(now, 10, TIMEOUT_PRIORITY_CONF, now);

	check(now, 0, TIMEOUT_PRIORITY_CONF, now+20);
	check(now, 0, TIMEOUT_PRIORITY_CONF, now+10);
	check(now, 0, TIMEOUT_PRIORITY_CONF, now+5);
	check(now, 0, TIMEOUT_PRIORITY_CONF, now);

	check(now, 10, TIMEOUT_PRIORITY_CONF, 0);
	check(now, 5, TIMEOUT_PRIORITY_CONF, 0);
	check(now, 0, TIMEOUT_PRIORITY_CONF, 0);

	check(now, 10, TIMEOUT_PRIORITY_APP, now+20);
	check(now, 10, TIMEOUT_PRIORITY_APP, now+10);
	check(now, 10, TIMEOUT_PRIORITY_APP, now+5);
	check(now, 10, TIMEOUT_PRIORITY_APP, now);

	check(now, 0, TIMEOUT_PRIORITY_APP, now+20);
	check(now, 0, TIMEOUT_PRIORITY_APP, now+10);
	check(now, 0, TIMEOUT_PRIORITY_APP, now+5);
	check(now, 0, TIMEOUT_PRIORITY_APP, now);

	check(now, 10, TIMEOUT_PRIORITY_APP, 0);
	check(now, 5, TIMEOUT_PRIORITY_APP, 0);
	check(now, 0, TIMEOUT_PRIORITY_APP, 0);

	return 0;
}
